const React = require('react');

const Array = React.createClass({
    propTypes: {
        value: React.PropTypes.arrayOf(React.PropTypes.oneOfType([React.PropTypes.object, React.PropTypes.func])).isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: []
        }
    },

    render() {
        let {label, validationState, validationMessage, value, onChange, options} = this.props;
        const {buildItem, disabled} = options || {};

        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                className: 'control-label'
            }, label) : null,
            React.createElement('div', {
                className: 'panel panel-default'
            }, React.createElement('div', {
                    className: 'panel-body'
                },
                ...value.map((item, index)=>React.createElement('div', null,
                    React.createElement('div', {style: {textAlign: 'right'}},
                        React.createElement('div', {
                                className: 'btn-group',
                                role: 'group'
                            },
                            React.createElement('button', {
                                className: 'btn btn-default',
                                type: 'button',
                                disabled,
                                onClick: index === 0 ? null : e=>onChange(value.slice(0, index - 1).concat(value[index], value[index - 1]).concat(value.slice(index + 1)), e)
                            }, React.createElement('span', {
                                className: 'glyphicon glyphicon-arrow-up',
                                ariaHidden: "true"
                            })),
                            React.createElement('button', {
                                className: 'btn btn-default',
                                type: 'button',
                                disabled,
                                onClick: index === value.length - 1 ? null : e=>onChange(value.slice(0, index).concat(value[index + 1], value[index]).concat(value.slice(index + 2)), e)
                            }, React.createElement('span', {
                                className: 'glyphicon glyphicon-arrow-down',
                                ariaHidden: "true"
                            }))
                        ),
                        React.createElement('div', {
                            className: 'btn-group',
                            role: 'group',
                            style: {marginLeft: '5px'}
                        }, React.createElement('button', {
                            className: 'btn btn-danger',
                            type: 'button',
                            disabled,
                            onClick: e=>onChange(value.slice(0, index).concat(value.slice(index + 1)), e)
                        }, React.createElement('span', {
                            className: 'glyphicon glyphicon-minus',
                            ariaHidden: "true"
                        })))
                    ),
                    typeof item === 'function' ? item() : item)),
                React.createElement('div', {style: {textAlign: 'right'}}, React.createElement('button', {
                    className: 'btn btn-default',
                    type: 'button',
                    disabled,
                    onClick: e=> onChange(value.concat(buildItem ? buildItem() : null), e)
                }, React.createElement('span', {
                    className: 'glyphicon glyphicon-plus',
                    ariaHidden: "true"
                })))
            )),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    }
});

Array.displayName = 'Array';

module.exports = Array;