const React = require('react');

const CheckboxGroup = React.createClass({
    propTypes: {
        value: React.PropTypes.arrayOf(React.PropTypes.string).isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: []
        }
    },

    render() {
        const {label, validationState, validationMessage, value, onChange, options} = this.props;
        const {items, disabled, inline} = options || {};

        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                className: 'control-label'
            }, label) : null,
            inline ? React.createElement('br') : null,
            ...(items && items.length > 0 ? items.map(item=>React.createElement('div', {
                    className: inline ? 'checkbox-inline' : 'checkbox'
                },
                React.createElement('label', null,
                    React.createElement('input', {
                        type: 'checkbox',
                        checked: (value || []).indexOf(item.value) >= 0,
                        disabled: item.disabled || disabled,
                        onChange: e=> onChange((value || []).concat(item.value).filter(v=> v !== item.value || e.target.checked), e)
                    }),
                    item.label || item.value
                )
            )) : []),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    }
});

CheckboxGroup.displayName = 'CheckboxGroup';

module.exports = CheckboxGroup;