const React = require('react');

const Group = React.createClass({
    propTypes: {
        value: React.PropTypes.arrayOf(React.PropTypes.oneOfType([React.PropTypes.object, React.PropTypes.func])).isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: []
        }
    },

    render() {
        const {label, validationState, validationMessage, value, onChange} = this.props;

        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                className: 'control-label'
            }, label) : null,
            React.createElement('div', {
                className: 'panel panel-default'
            }, React.createElement('div', {
                className: 'panel-body'
            }, ...(value || []).map(item=>typeof item === 'function' ? item() : item))),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    }
});

Group.displayName = 'Group';

module.exports = Group;