const React = require('react');

const Password = React.createClass({
    propTypes: {
        value: React.PropTypes.string.isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: ''
        }
    },

    componentWillMount() {
        this.id = Math.random() + '';
    },

    render() {
        const {label, validationState, validationMessage, value, onChange, options} = this.props;

        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                htmlFor: this.getId(),
                className: 'control-label'
            }, label) : null,
            React.createElement('input', Object.assign({
                id: this.getId(),
                type: 'password',
                className: 'form-control',
                value,
                onChange: e=>onChange(e.target.value, e)
            }, options)),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    },

    getId() {
        return this.props.id || this.id;
    }
});

Password.displayName = 'Password';

module.exports = Password;