const React = require('react');

const RadioGroup = React.createClass({
    propTypes: {
        value: React.PropTypes.string.isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: ''
        }
    },

    render() {
        const {label, validationState, validationMessage, value, onChange, options} = this.props;
        const {items, disabled, inline} = options || {};

        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                className: 'control-label'
            }, label) : null,
            inline ? React.createElement('br') : null,
            ...(items && items.length > 0 ? items.map(item=>React.createElement('div', {
                    className: inline ? 'radio-inline' : 'radio'
                },
                React.createElement('label', null,
                    React.createElement('input', {
                        type: 'radio',
                        checked: value === item.value,
                        disabled: item.disabled || disabled,
                        onChange: e=> onChange(item.value, e)
                    }),
                    item.label || item.value
                )
            )) : []),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    }
});

RadioGroup.displayName = 'RadioGroup';

module.exports = RadioGroup;