const React = require('react');

const Select = React.createClass({
    propTypes: {
        value: React.PropTypes.oneOfType([React.PropTypes.bool, React.PropTypes.string, React.PropTypes.arrayOf(React.PropTypes.string)]).isRequired,
        onChange: React.PropTypes.func.isRequired
    },

    getDefaultProps() {
        return {
            value: false
        }
    },

    render() {
        let {label, validationState, validationMessage, value, onChange, options} = this.props;
        const {items, disabled, multiple} = options || {};

        if (!value) value = multiple ? [] : '';
        let wrapperClassName = 'form-group';
        if (validationState) wrapperClassName = wrapperClassName + ' has-' + validationState;

        return React.createElement('div', {
                className: wrapperClassName
            },
            label ? React.createElement('label', {
                className: 'control-label'
            }, label) : null,
            React.createElement('select', {
                    className: 'form-control',
                    multiple,
                    value,
                    onChange: multiple ?
                        e=>onChange(Array.from(e.target.options).filter(option=>option.selected).map(option=>option.value), e)
                        :
                        e=>onChange(e.target.value, e)
                },
                ...(items && items.length > 0 ? items.map(item=>React.createElement('option', {
                        value: item.value,
                        disabled: item.disabled || disabled
                    },
                    item.label || item.value
                )) : [])
            ),
            validationMessage ? React.createElement('span', {
                className: 'help-block'
            }, validationMessage) : null
        )
    }
});

Select.displayName = 'Select';

module.exports = Select;