require('bootstrap/dist/css/bootstrap.css');

const React = require('react');
const ReactDOM = require('react-dom');

const Fields = require('../lib/index');

const TestPage = React.createClass({
    getInitialState() {
        return {
            //textValue: 'default value',
            //passwordValue: '123456',
            //fileValue: '',
            //textareaValue: 'long text',
            //checkboxGroupValue: [],
            //radioGroupValue: '',
            //singleSelectValue: '',
            //multipleSelectValue: [],
            groupValue: [this.buildTextField, this.buildTextField],
            arrayValue: [this.buildTextField, this.buildTextField]
        }
    },

    render() {
        return React.createElement('div', null,
            React.createElement(Fields.Text, {
                label: 'Text',
                value: this.state.textValue,
                onChange: value=>this.setState({textValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    placeholder: 'input some text'
                }
            }),

            React.createElement(Fields.Password, {
                label: 'Password',
                value: this.state.passwordValue,
                onChange: value=>this.setState({passwordValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    placeholder: 'input password'
                }
            }),

            React.createElement(Fields.File, {
                label: 'File',
                value: this.state.fileValue,
                onChange: value=>this.setState({fileValue: value}),
                validationMessage: 'validation message',
                validationState: 'success'
            }),

            React.createElement(Fields.Textarea, {
                label: 'Textarea',
                value: this.state.textareaValue,
                onChange: value=>this.setState({textareaValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    rows: 3
                }
            }),

            React.createElement(Fields.CheckboxGroup, {
                label: 'CheckboxGroup',
                value: this.state.checkboxGroupValue,
                onChange: value=>this.setState({checkboxGroupValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    inline: true,
                    items: [
                        {label: 'Man', value: 'man'},
                        {label: 'Woman', value: 'woman', disabled: true}
                    ]
                }
            }),

            React.createElement(Fields.RadioGroup, {
                label: 'RadioGroup',
                value: this.state.radioGroupValue,
                onChange: value=>this.setState({radioGroupValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    inline: false,
                    items: [
                        {label: 'Man', value: 'man'},
                        {label: 'Woman', value: 'woman'},
                        {label: 'Super', value: 'super', disabled: true}
                    ]
                }
            }),

            React.createElement(Fields.Select, {
                label: 'SingleSelectGroup',
                value: this.state.singleSelectValue,
                onChange: value=>this.setState({singleSelectValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    items: [
                        {label: '-', value: '', disabled: true},
                        {label: 'Man', value: 'man'},
                        {label: 'Woman', value: 'woman'},
                        {label: 'Super', value: 'super', disabled: true}
                    ]
                }
            }),

            React.createElement(Fields.Select, {
                label: 'MultipleSelectGroup',
                value: this.state.multipleSelectValue,
                onChange: value=>this.setState({multipleSelectValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    multiple: true,
                    items: [
                        {label: '-', value: '', disabled: true},
                        {label: 'Man', value: 'man'},
                        {label: 'Woman', value: 'woman'},
                        {label: 'Super', value: 'super', disabled: true}
                    ]
                }
            }),

            React.createElement(Fields.Group, {
                label: 'Group',
                value: this.state.groupValue,
                onChange: value=>this.setState({groupValue: value}),
                validationMessage: 'validation message',
                validationState: 'success'
            }),

            React.createElement(Fields.Array, {
                label: 'Array',
                value: this.state.arrayValue,
                onChange: value=>this.setState({arrayValue: value}),
                validationMessage: 'validation message',
                validationState: 'success',
                options: {
                    buildItem: Math.random
                }
            })
        )
    },

    buildTextField() {
        return React.createElement(Fields.Text, {
            label: 'Text',
            value: this.state.textValue,
            onChange: value=>this.setState({textValue: value}),
            validationMessage: 'validation message',
            validationState: 'success',
            options: {
                placeholder: 'input some text'
            }
        })
    }
});

TestPage.displayName = 'TestPage';

let root = document.getElementById('root');
if (!root) {
    root = document.createElement('div');
    root.id = 'root';
    document.body.appendChild(root);
}

ReactDOM.render(
    React.createElement(TestPage),
    root
);
